// UniverzalniPole.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <conio.h>

// includovanim tohoto souboru jsme ziskali pouze funkci pridej(), ktera vlozi
// prvek do pole a nadefinovany identifikator MAX_POCET_PRVKU, ktery nam rika,
// kolik prvku lze maximalne pomoci funkce pridej vlozit. Uz nas nezajima, ze
// se to uklada do pole a jak je to udelano... Klidne by se to mohlo ukladat
// treba do stromu a my k tomu budeme pristupovat stejne.
// Dale jeste funkci vrat_mi_prvni_a_vyjmi(), ktera bude slouzit pro vyprazdneni
// pole.
#include "Pole.h"

// Tato funkce zajisti porovnavani prvku. Pole si uklada pouze pointery na neco,
// o cem nevi co to skutene je, takze to nemuze ani porovnavat a musi volat za timto
// ucelem nasi funkci, ktera to umi
// Vrati -1 pokud prvni prvek je mensi nez druhy, 0 pokud jsou stejne a 1 kdyz prvni
// je vetsi nez druhy
int porovnej(void * p1, void * p2)
{
	if (*(int *)p1 == *(int *)p2)
		return 0;

	return (*(int *)p1 < *(int *)p2) ? -1 : 1;
}

// A hlavni program, ktery pole otestuje. Vlozi tam prvky, ktere nacte od uzivatele
// a pak tyto prvky postupne vyjme a vypise.
int main()
{
	puts("Zadejte deset cisel:");
	for (int i = 0; i < MAX_POCET_PRVKU; i++)
	{
		// musime si naalokovat pamet, na kterou dame ukazatel
		int * px = (int *) malloc(sizeof(int));
		// do teto pameti nacteme cislo
		scanf("%d", px);
		// a zaradime ho do pole
		pridej(px, porovnej);
	}

	puts("Vypisuji pole:");
	for (int i = 0; i < MAX_POCET_PRVKU; i++)
	{
		// dostaneme ukazatel
		int * px = (int *)vrat_mi_prvni_a_vyjmi();
		// vypiseme obsah pameti, kam ukazatel ukazuje
		printf("%d\n", *px);
		// a pamet zase uvolnime
		free(px);
	}

	getch();
	return 0;
}

